<template>
  <v-dialog v-model="value" scrollable max-width="700px" persistent>
    <v-card>
      <v-card-text>
        <v-stepper v-model="currentStep" alt-labels>
          <!-- HEADER -->
          <v-stepper-header>
            <template v-for="(step, index) in steps">
              <v-stepper-step :key="`${index+1}-step`" :complete="currentStep > index+1" :step="index+1">
                <span class="text-center">{{ step }}</span>
              </v-stepper-step>
              <v-divider v-if="index+1 !== steps.length" :key="index+1"/>
            </template>
          </v-stepper-header>

          <!-- STEPS -->
          <v-stepper-items>
            <v-stepper-content v-for="(n,index) in steps" :key="`${index+1}-content`" :step="index+1">
              <div class="content-header" v-if="index > 0">
                <v-btn
                  x-small text
                  @click="goBack(index+1)"
                  class="btnback">
                  Regresar
                </v-btn>
              </div>
              <!-- STEP 1: select student -->
              <div v-if="index+1 === 1">
                <st-first-step
                  @next="nextStep(index+1, $event)"
                  @cancel="$emit('cancel')"/>
              </div>
              <!-- STEP 2: validate last appointment -->
              <div v-if="index+1 === 2">
                <st-second-step
                  :appointment="appointment"
                  @next="nextStep(index+1, $event)"
                  @cancel="$emit('cancel')"/>
              </div>
              <!-- STEP 3: select appointment date & tutor -->
              <div v-if="index+1 === 3">
                <st-third-step
                  :loading="registerLoading"
                  :appointment="appointment"
                  @next="registerAppointment($event)"
                  @cancel="$emit('cancel')"/>
              </div>
            </v-stepper-content>
          </v-stepper-items>
        </v-stepper>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import TutorshipSessionModalStepOne from "./TutorshipSessionModalStepOne";
import TutorshipSessionModalStepTwo from "./TutorshipSessionModalStepTwo";
import TutorshipSessionModalStepThree from "./TutorshipSessionModalStepThree";

export default {
  name: "TutorshipSessionModal",
  components: {
    'st-first-step': TutorshipSessionModalStepOne,
    'st-second-step': TutorshipSessionModalStepTwo,
    'st-third-step': TutorshipSessionModalStepThree,
  },
  props:['value'],
  data() { return {
    currentStep: 1,
    appointment: {student: null},
    registerLoading: false,
    steps:[
      'Seleccionar a un alumno',
      'Verificar estado de última cita',
      'Selección de fecha con tutor',
    ],
  }},
  methods: {
    goBack(index) {
      this.currentStep = index - 1;
    },
    nextStep(n, data) {
      // first step completed, student received
      if (n === 1) this.appointment.student = data;
      // second step completed, validated

      this.currentStep += 1;
    },
    async registerAppointment(data) {
      try {
        this.registerLoading = true;
        // validating all data
        let toSend = {
          alumnos: [this.appointment.student.idAlumno],
          idUnidad: this.$store.state.role.idUnit,
          idTutoria: this.$route.params.id,
          sesion: {
            idTutorAsignado: data.idTutor,
            fechaInicio: data.start,
            fechaFin: data.end
          }
        };
        const response = await this.$api.registerAppointment(toSend);
        this.$emit('refreshData');
      } catch (error) {
        console.error(error)
        this.$store.commit('setError', error)
       }
      this.registerLoading = false;
    }
  }
}
</script>

<style scoped>
  .v-card__text{
    padding:0 !important
  }
</style>
